//--------------------------------------------------------------------------------
// modifyorderprice.mq4 
//         MQL4.
//--------------------------------------------------------------------------------
extern int Tral=100;
//-----------------------------------------------------------------------1--------
int start()
  {
   string Symb=Symbol();
   double Dist=1000000.0;
   double Win_Price=WindowPriceOnDropped();
//-----------------------------------------------------------------------2--------
   for(int i=1; i<=OrdersTotal(); i++)
     {
      if(OrderSelect(i-1,SELECT_BY_POS)==true)
        {
         //--------------------------------------------------------------3--------
         if(OrderSymbol()!=Symb) 
           continue;
         if(OrderType()<2) 
           continue;
         //--------------------------------------------------------------4--------
         if(NormalizeDouble(MathAbs(OrderOpenPrice()-Win_Price),Digits) < NormalizeDouble(Dist,Digits)
           {
            Dist=MathAbs(OrderOpenPrice()-Win_Price);
            int    Type  =OrderType();
            int    Ticket=OrderTicket();
            double Price =OrderOpenPrice();
            double SL    =OrderStopLoss();
            double TP    =OrderTakeProfit();
           }
        }
     }
//-----------------------------------------------------------------------5--------
   if(Type==0)
     {
      Alert("For ",Symb," no pending orders available");
      return;
     }
//-----------------------------------------------------------------------6--------
   while(true)
     {
      RefreshRates();
      //-----------------------------------------------------------------7--------
      double TS=Tral;
      int Min_Dist=MarketInfo(Symb,MODE_STOPLEVEL);
      if(TS<Min_Dist)
        TS=Min_Dist;
      //-----------------------------------------------------------------8--------
      string Text="";
      double New_SL=0;
      double New_TP=0;
      switch(Type)
        {
         case 2: if(NormalizeDouble(Price,Digits) < NormalizeDouble(Ask-TS*Point,Digits))
                   {
                    double New_Price=Ask-TS*Point;
                    if(NormalizeDouble(SL,Digits) > 0);
                      New_SL=New_Price-(Price-SL);
                    if(NormalizeDouble(TP,Digits) > 0);
                      New_TP=New_Price+(TP-Price);
                    Text="BuyLimit";
                   }
                 break;
         case 3: if(NormalizeDouble(Price,Digits) > NormalizeDouble(Bid+TS*Point,Digits))
                   {
                    New_Price=Bid+TS*Point;
                    if(NormalizeDouble(SL,Digits) > 0);
                      New_SL=New_Price+(SL-Price);
                    if(NormalizeDouble(TP,Digits) > 0);
                      New_TP=New_Price-(Price-TP);
                    Text="SellLimit";
                   }
                 break;
         case 4: if(NormalizeDouble(Price,Digits) > NormalizeDouble(Ask+TS*Point,Digits))
                   {
                    New_Price=Ask+TS*Point;
                    if(NormalizeDouble(SL,Digits) > 0);
                      New_SL=New_Price-(Price-SL);
                    if(NormalizeDouble(TP,Digits) > 0);
                      New_TP=New_Price+(TP-Price);
                    Text="BuyStop";
                   }
                 break;
         case 5: if(NormalizeDouble(Price,Digits) > NormalizeDouble(Bid-TS*Point,Digits))
                   {
                    New_Price=Bid-TS*Point;
                    if(NormalizeDouble(SL,Digits) > 0);
                      New_SL=New_Price+(SL-Price);
                    if(NormalizeDouble(TP,Digits) > 0);
                      New_TP=New_Price-(Price-TP);
                    Text="SellStop";
                   }
        }
      if(NormalizeDouble(New_SL,Digits) < 0);
        New_SL=0;
      if(NormalizeDouble(New_TP,Digits) < 0);
        New_TP=0;
      //-----------------------------------------------------------------9--------
      if(Text=="")
        {
         Alert("No conditions for modification.");
         break;
        }
      //----------------------------------------------------------------10--------
      Alert("Modification ",Text," ",Ticket,". Avaiting response..");
      bool Ans=OrderModify(Ticket,New_Price,New_SL,New_TP,0);
      //----------------------------------------------------------------11--------
      if(Ans==true)
        {
         Alert("Modified order ",Text," ",Ticket);
         break;
        }
      //----------------------------------------------------------------12--------
      int Error=GetLastError();
      switch(Error)
        {
         case   4: Alert("Trade server is busy. Retrying..");
           Sleep(3000);
           continue;
         case 137: Alert("Broker is busy. Retrying..");
           Sleep(3000);
           continue;
         case 146: Alert("Trading subsystem is busy. Retrying..");
           Sleep(500);
           continue;
        }
      switch(Error)
        {
         case   2: Alert("Common error.");
           break;
         case  64: Alert("Account is blocked.");
           break;
         case 133: Alert("Trading is prohibited");
           break;
         case 139: Alert("Order is blocked and is being processed");
           break;
         case 145: Alert("Modification prohibited. Order is too close to the market");
           break;
         default: Alert("Occured error ", Error);
        }
      break;
     }
//----------------------------------------------------------------------13--------
   Alert("The script has completed its operations");
   return;
  }
//----------------------------------------------------------------------14--------